JUCE: SoundPlayer Class Reference

JUCE

Public Member Functions | List of all members
SoundPlayer Class Reference
juce_audio_utils » players

A simple sound player that you can add to the AudioDeviceManager to play simple sounds. More...

`#include <juce_SoundPlayer.h>`

Inheritance diagram for SoundPlayer:

## Public Member Functions
| SoundPlayer ()
| ~SoundPlayer () override
| Destructor. More...
void | play (const File &file)
| Plays a sound from a file. More...
void | play (const void *resourceData, size_t resourceSize)
| Convenient method to play sound from a JUCE resource. More...
void | play (AudioFormatReader *buffer, bool deleteWhenFinished=false)
| Plays the sound from an audio format reader. More...
void | play (PositionableAudioSource *audioSource, bool deleteWhenFinished=false, double sampleRateOfSource=0.0)
| Plays the sound from a positionable audio source. More...
void | play (AudioBuffer< float > *buffer, bool deleteWhenFinished=false, bool playOnAllOutputChannels=false)
| Plays the sound from an audio sample buffer. More...
void | playTestSound ()
| Plays a beep through the current audio device. More...
void | audioDeviceIOCallback (const float **, int, float **, int, int) override
void | audioDeviceAboutToStart (AudioIODevice *) override
void | audioDeviceStopped () override
void | audioDeviceError (const String &errorMessage) override
Public Member Functions inherited from AudioIODeviceCallback
virtual | ~AudioIODeviceCallback ()=default
| Destructor. More...
virtual void | audioDeviceIOCallbackWithContext (const float **inputChannelData, int numInputChannels, float **outputChannelData, int numOutputChannels, int numSamples, const AudioIODeviceCallbackContext &context)
| The same as audioDeviceIOCallback(), but with an additional context argument. More...

## Detailed Description

A simple sound player that you can add to the AudioDeviceManager to play simple sounds.

See also
  AudioProcessor, AudioProcessorGraph

## Constructor & Destructor Documentation

## ◆ SoundPlayer()

SoundPlayer::SoundPlayer | ( |  | ) |

## ◆ ~SoundPlayer()

SoundPlayer::~SoundPlayer | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ play() [1/5]

void SoundPlayer::play | ( | const File & | file | ) |

Plays a sound from a file.

## ◆ play() [2/5]

void SoundPlayer::play | ( | const void * | resourceData,
|  | size_t | resourceSize
| ) |  |

Convenient method to play sound from a JUCE resource.

## ◆ play() [3/5]

void SoundPlayer::play | ( | AudioFormatReader * | buffer,
|  | bool | deleteWhenFinished = `false`
| ) |  |

Plays the sound from an audio format reader.

If deleteWhenFinished is true then the format reader will be automatically deleted once the sound has finished playing.

## ◆ play() [4/5]

void SoundPlayer::play | ( | PositionableAudioSource * | audioSource,
|  | bool | deleteWhenFinished = `false`,
|  | double | sampleRateOfSource = `0.0`
| ) |  |

Plays the sound from a positionable audio source.

This will output the sound coming from a positionable audio source. This gives you slightly more control over the sound playback compared to the other playSound methods. For example, if you would like to stop the sound prematurely you can call this method with a TransportAudioSource and then call audioSource->stop. Note that, you must call audioSource->start to start the playback, if your audioSource is a TransportAudioSource.

The audio device manager will not hold any references to this audio source once the audio source has stopped playing for any reason, for example when the sound has finished playing or when you have called audioSource->stop. Therefore, calling audioSource->start() on a finished audioSource will not restart the sound again. If this is desired simply call playSound with the same audioSource again.

Parameters

  audioSource | the audio source to play
  deleteWhenFinished | If this is true then the audio source will be deleted once the device manager has finished playing.
  sampleRateOfSource | The sample rate of the source. If this is zero, JUCE will assume that the sample rate is the same as the audio output device.

## ◆ play() [5/5]

void SoundPlayer::play | ( | AudioBuffer< float > * | buffer,
|  | bool | deleteWhenFinished = `false`,
|  | bool | playOnAllOutputChannels = `false`
| ) |  |

Plays the sound from an audio sample buffer.

This will output the sound contained in an audio sample buffer. If deleteWhenFinished is true then the audio sample buffer will be automatically deleted once the sound has finished playing.

If playOnAllOutputChannels is true, then if there are more output channels than buffer channels, then the ones that are available will be re-used on multiple outputs so that something is sent to all output channels. If it is false, then the buffer will just be played on the first output channels.

## ◆ playTestSound()

void SoundPlayer::playTestSound | ( |  | ) |

Plays a beep through the current audio device.

This is here to allow the audio setup UI panels to easily include a "test" button so that the user can check where the audio is coming from.

## ◆ audioDeviceIOCallback()

void SoundPlayer::audioDeviceIOCallback | ( | const float ** | ,
|  | int | ,
|  | float ** | ,
|  | int | ,
|  | int |
| ) |  |
| overridevirtual

Reimplemented from AudioIODeviceCallback.

## ◆ audioDeviceAboutToStart()

void SoundPlayer::audioDeviceAboutToStart | ( | AudioIODevice * |  | ) |
| overridevirtual

Implements AudioIODeviceCallback.

## ◆ audioDeviceStopped()

void SoundPlayer::audioDeviceStopped | ( |  | ) |
| overridevirtual

Implements AudioIODeviceCallback.

## ◆ audioDeviceError()

void SoundPlayer::audioDeviceError | ( | const String & | errorMessage | ) |
| overridevirtual

Reimplemented from AudioIODeviceCallback.

The documentation for this class was generated from the following file:

- juce_SoundPlayer.h